provide contribs link and prevent mobile user without user page from being dumped into blank screen when they click their username
Closed, ResolvedPublic8 Story Points

Description

If a user clicks their username and they do not have a user page they should either see our special:userprofile page or a CTA that asks if they want to create one.

There also needs to be a link to contribs and user talk page somewhere on the mobile site.

Final mocks

  • HTML prototype for styles and assets
    http://nirzar.github.io/prototypes/mobile-web/userpages/index.html

    Acceptance criteria:

    • Content should be served via User namespace
    • Content below header should come from the user's user page.
    • Visiting Special:UserProfile in beta should redirect you to the user page.
    • Clicking talk button in user page should open the JavaScript talk dialog to be consistent with main page
    • Remove browser tests for user profiles[A]
    • should be done when pushing to stable - added to T120685

    Related Objects

    There are a very large number of changes, so older changes are hidden. Show Older Changes
    Nirzar added a comment.Dec 2 2015, 3:56 PM

    @Florian @JKatzWMF

    So i think we don't have enough information to support our hypothesis of showing user metric on userpages but links to contributions and talk page are important.
    here's another iteration of the user pages based on all the feedback.

    • I have removed the edit and upload counts.
    • reduced the height of the header so there's more space for the actual user page.

    So glad we are progressing with this, however:

    • Do we want to move the conversation to wiki to get a broader audience feedback?
    • On desktop, are we considering, any hint that updates the user on how their page will look like on mobile?
    • The discussion around data sets display, is tied to the question of what is the use of the user page on mobile (trust? finding common themes across users? connecting with others? just another page? etc) and how do users want to present themselves on mobile.

    @Moushira

    Do we want to move the conversation to wiki to get a broader audience feedback?

    In the interest of time, I would like to see if the folks who feel strongly about this can provide usable feedback. We have some slack in our engineering schedule that I could see this fitting into and if it doesn't fit in, I am not confident it will be done by the reading team anytime soon.

    On desktop, are we considering, any hint that updates the user on how their page will look like on mobile?

    No, simply because that is a broader issue of showing users how their edits will look on mobile. I think this ticket captures that need: T119252

    The discussion around data sets display, is tied to the question of what is the use of the user page on mobile (trust? finding common themes across users? connecting with others? just another page? etc) and how do users want to present themselves on mobile.

    Agreed. Removing the stat hopefully tables that question for the time being

    JKatzWMF edited the task description. (Show Details)Dec 3 2015, 12:36 AM

    @Risker @Legoktm @Florian @MZMcBride

    Hey, I think Nirzar's latest (now in the description) have taken the major concerns around this improvement into account. This our attempt to pull the special user page, while retaining the important link and providing a call-to-action for users without a page.

    If you have any new concerns, or feel we have failed to address any of the ones you have previously raised, I'd like to suggest that they are raised by Friday 6pm GMT. This way we will have a chance to size-up the work to potentially work on it this quarter.

    @Florian @JKatzWMF

    So i think we don't have enough information to support our hypothesis of showing user metric on userpages but links to contributions and talk page are important.

    Exactly that's, what I mean :) Thanks for bringing it to such a simple sentence :P

    • I have removed the edit and upload counts.

    +1

    • reduced the height of the header so there's more space for the actual user page.

    In fact, we could even more reduce the size of the header by removing the "Member since..." message. That's like an edit count: As a normal user, you can't get any benefit from it. Maybe the user contributed to the wiki before, too, but only as an IP, or he was active as a reader, too. Or, he's already active a long time in another wiki of a wiki farm (e.g., in wmf wikis, in other CentralAuth wikis), but autocreated an account on _this_ wiki just a month ago (which would be the date of registration, we would get with the user object, iirc). So if you feel ok, I would suggest to remove that, too, or, at least, move it to a less prominent place. But, in general, I would be ok with this design. It would be way better as the current one!

    @Risker @Legoktm @Florian @MZMcBride
    This our attempt to pull the special user page,

    I think we don't need a special page for this, anymore. I haven't looked at the code, but it should be possible (hopefully) to kill Special:UserProfile by implementing the design provided by @Nirzar.

    Keegan added a subscriber: Keegan.Dec 3 2015, 10:35 PM

    In fact, we could even more reduce the size of the header by removing the "Member since..." message. That's like an edit count: As a normal user, you can't get any benefit from it. Maybe the user contributed to the wiki before, too, but only as an IP, or he was active as a reader, too. Or, he's already active a long time in another wiki of a wiki farm (e.g., in wmf wikis, in other CentralAuth wikis), but autocreated an account on _this_ wiki just a month ago (which would be the date of registration, we would get with the user object, iirc). So if you feel ok, I would suggest to remove that, too, or, at least, move it to a less prominent place. But, in general, I would be ok with this design. It would be way better as the current one!

    Or, if it must be kept, "Registered on..." might make more sense.

    Or, if it must be kept, "Registered on..." might make more sense.

    I think the time period (6 yr 2months) is easy to digest than than a date (10 Jan 2009)

    Risker added a comment.Dec 4 2015, 4:55 AM

    I can't tell who the intended "user" of this proposed page design is. Are you trying to create something useful for casual readers who don't really edit? Experienced editors? New users?

    "Edit history" is not a helpful term because it is not clear whether it refers to the editing history of the page or the user. If you really feel the need to link to the user's contributions, use proper terminology and call it User Contributions and link to the Special:Contributions page for the user (incidentally, it includes uploads). If you want to link to the page's editing history, call it "page history". Leave the uploads off regardless, they're irrelevant in just about every way I can think of, and it looks to me like it was included simply to provide visual balance to the header. Leave off the registration date ("member since") because it's meaningless too: a huge percentage of accounts were registered and abandoned without a single edit.

    If a user has created a userpage, then their page should be shown. If not, then whatever is shown should be as minimalist as possible; talk page link and link to user contribs would be the maximum, in my mind. It may come as a surprise, but tens of thousands of users deliberately choose not to have a userpage or alternately to maintain a blank userpage. (My userpage on Meta is deliberately blank, for example - it used to have content, but I didn't want it propagated throughout the WMF world so removed it.)

    Nirzar added a comment.Dec 4 2015, 4:52 PM

    call it User Contributions and link to the Special:Contributions page

    +1 definitely, i will update the mocks

    Nirzar edited the task description. (Show Details)Dec 4 2015, 4:55 PM
    Nirzar added a mock: M125: User pages.
    JKatzWMF added a comment.EditedDec 4 2015, 7:23 PM

    Thanks @Risker. I think we can remove the uploads link as well as the 'member since' info if others agree.

    I can't tell who the intended "user" of this proposed page design is. Are you trying to create something useful for casual readers who don't really edit? Experienced editors? New users?

    There are multiple intended users of this:

    • we are surfacing the existing userpage trying to improve the situation for editors with user pages who wanted those to show without an intermediary.
    • we added standard links to improve the situation for editors trying to learn about other editors
    • by adding some basic stats we were hoping to serve readers who might be curious about who had updated a page
    • by adding a notification when there was no user page: we are serving readers who would have otherwise seen a blank screen (or a notification that treated it like any other page that was missing). Unlike most pages, if you are THE user, you should be invited to create a page. If you are not THE user, you should not be.

    @Jdlrobson can you attempt to scope this work for next sprint? I know you assigned it 13 pts verbally yesterday, but wanted to make sure you saw the most recent proposal, which is a header and some conditional messaging.

    Jdlrobson edited the task description. (Show Details)Dec 5 2015, 1:34 AM
    Jdlrobson edited a custom field.
    Jdlrobson edited the task description. (Show Details)Dec 5 2015, 1:37 AM

    @JKatzWMF the mock doesn't seem up to date in the description.
    @Nirzar please see my open questions

    Nirzar added a comment.Dec 5 2015, 2:36 AM

    @Jdlrobson can you point me to your open questions. are they in this ticket?

    Nirzar added a comment.Dec 5 2015, 2:37 AM

    @Jdlrobson can you point me to your open questions. are they in this ticket?

    nevermind, found it in task description

    Nirzar added a comment.EditedDec 5 2015, 2:46 AM

    How does a user edit their existing user page? - not clear from mock

    Okay, just realized the mock has one issue.

    So for now the edit and watchlist will be present exactly in the same page as they do on current userpages.

    for e.g. John's page right now looks like this

    it will look like this

    Are we not killing the uploads feature?

    I think it is useful

    Are we not killing the uploads feature?

    I think it is useful

    Okay. How will the menu with talk, contributions and uploads work on a 240px screen or a 320px screen where the words are bigger e.g. in a different language?

    Will we hide options? Will we stack the buttons? Will we truncate text and force a fixed width?

    Nirzar added a comment.EditedDec 6 2015, 5:43 AM

    @Jdlrobson i haven't created a spec yet because this discussion for now was only meant for iterating on design. now that we have an idea about what we want to do i will create a detailed spec with all the required assets, which will take care of the things you are asking. Hold on till I put up the visual spec first on Pholio.

    Note we never clarified if this was straight to production or beta. I'm guessing beta. If so I guess iterating design is okay but I was told this was going to be a one sprint thing.

    Also can you merge T102528 into this card if this covers that?

    Nirzar edited the task description. (Show Details)Dec 7 2015, 8:56 PM
    Jdlrobson edited the task description. (Show Details)Dec 8 2015, 8:17 PM
    Jdlrobson removed Nirzar as the assignee of this task.Dec 14 2015, 10:30 PM
    Jdlrobson added a subscriber: Nirzar.

    Change 259267 had a related patch set uploaded (by Bmansurov):
    WIP: Enhanced User page

    https://gerrit.wikimedia.org/r/259267

    Jdlrobson changed the status of subtask T120685: Deploy new mobile userpage header to stable from "Open" to "Stalled".Dec 15 2015, 5:38 PM

    A few things need fixing before this can be considered done so I've moved this back to ready for dev.

    Change 259267 merged by jenkins-bot:
    Enhanced user page in minerva beta

    https://gerrit.wikimedia.org/r/259267

    Change 260321 had a related patch set uploaded (by Bmansurov):
    Redirect Special:UserProfile/Username to User:Username in beta

    https://gerrit.wikimedia.org/r/260321

    Change 260324 had a related patch set uploaded (by Bmansurov):
    Beta: Add talk overlay to the user page

    https://gerrit.wikimedia.org/r/260324

    Change 260324 merged by jenkins-bot:
    Beta: Add talk overlay to the user page

    https://gerrit.wikimedia.org/r/260324

    @bmansurov Hey, is it possible to get a screenshot of this patch? i wanted to take a look.

    @Nirzar, sure:

    1. User who has a user page:
    2. User who doesn't have a user page (viewed by another user):
    3. User who doesn't have a user page (viewed by the user himself/herself):
    4. Talk page when the user clicks on the talk link:

    @bmansurov looks good, the padding on left and right on 2,3 looks cramped. i am guessing it's the screenshot which is cropped that way. it looks correct in the thumbnail view.

    https://phab.wmfusercontent.org/file/data/gvjtcscjrufuo6wzfyyt/PHID-FILE-x2sg3wpjolhdv3rbpm2n/v3aa66o4xagrkdpu/Screen_Shot_2015-12-21_at_8.57.37_PM.png

    this looks crapped on left and right.almost touching

    Yeah, it's just the way screenshots are taken. ;)

    Change 260321 merged by jenkins-bot:
    Redirect Special:UserProfile/Username to User:Username in beta

    https://gerrit.wikimedia.org/r/260321

    (Note redirect patch is merged but for some reason http://en.m.wikipedia.beta.wmflabs.org/wiki/Special:UserProfile/Jdlrobson isn't redirecting - will try again later)

    @Jdlrobson it's to the spec :) i have yet to see my own blank page when logged in. but @bmansurov's screenshot looks good.

    kaldari removed a subscriber: kaldari.Dec 22 2015, 1:01 AM

    @bmansurov, I just saw this now. The screenshot for "User who doesn't have a user page (viewed by another user)" has a line "Create this page" that looks like a link. Link or no link, surely that doesn't belong on a page seen by another user.

    @Nirzar, what do you say about the above comment? ^ There was a link in the mock-up.

    @Thnidu on wikipedia you can technically create any page. to replicate, log in from your wikipedia account and visit this https://en.wikipedia.org/wiki/User:Nirzardp the message says

    In general, this page should be created and edited by User:Nirzardp.

    but still gives you a way to create this page. this means you can create anyone's userpage. we have to retain functionality when redoing this layout.

    I agree it shouldn't be there but it has to be :)

    Qgil removed a subscriber: Qgil.Dec 22 2015, 5:38 PM
    Jdlrobson closed this task as "Resolved".Dec 29 2015, 8:48 PM
    Jdlrobson moved this task from Ready for Signoff to Done on the Reading-Web-Sprint-63-Ellip… board.